--- include/sound/asound.h.orig	2009-09-09 14:34:54.000000000 +0200
+++ include/sound/asound.h	2009-09-14 23:27:31.000000000 +0200
@@ -62,6 +62,31 @@
 #include <sys/ioctl.h>
 #endif
 
+#ifdef __FreeBSD__
+#define ESTRPIPE	0x7a69	/* Linux PCM suspend errno, fehh?! */
+#define EBADFD		EBADF
+
+#define bswap_16(x)	bswap16(x)
+#define bswap_32(x)	bswap32(x)
+#define bswap_64(x)	bswap64(x)
+
+#if __BYTE_ORDER == __LITTLE_ENDIAN
+#define __cpu_to_le32(x) (x)
+#define __cpu_to_be32(x) bswap_32(x)
+#define __cpu_to_le16(x) (x)
+#define __cpu_to_be16(x) bswap_16(x)
+#else
+#define __cpu_to_le32(x) bswap_32(x)
+#define __cpu_to_be32(x) (x)
+#define __cpu_to_le16(x) bswap_16(x)
+#define __cpu_to_be16(x) (x)
+#endif
+
+#define __le32_to_cpu __cpu_to_le32
+#define __be32_to_cpu __cpu_to_be32
+#define __le16_to_cpu __cpu_to_le16
+#define __be16_to_cpu __cpu_to_be16
+#endif
 /*
  *  protocol version
  */
